<?php
namespace Teknisa\FIS\Controllers;

use Teknisa\FIS\Services\Fis22100ParametrosPreValidacaoService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;


class Fis22100ParametrosPreValidacaoController extends \Teknisa\FIS\Controllers\TeknisaCrud{

    protected $dataSourceName ='paramprevalid';
    protected $parameterBag;
    protected $crudService;
    protected $dataSourceNameToSave  = false;
    protected $service;

    public function __construct($crudService, ParameterBag $parameterBag, Fis22100ParametrosPreValidacaoService $service) {
        $this->service = $service;
        parent::__construct($crudService, $parameterBag);
    }

    public function find(DTO\Request\Filter $request, DTO\Response $response) {
        try {
            //$this->dataSourceName='paramprevalid';
            parent::find($request, $response);
            $dataSet = $response->getDataSets();

            if(!empty($dataSet)){
                $rows = $dataSet[0]->getRows();
                $dados = $this->service->setDataTipoOperacao($rows);
                $dataSet = new DataSet("paramprevalid_completo", $dados);
                $response->setDataSets(array($dataSet));
            }

        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

    public function save(DTO\Request $request, DTO\Response $response) {
        try {
            //$this->dataSourceName='';
            parent::save($request, $response);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 500));
        }
    }

}
